<template>
  <div class="p-2">
    <transition :enter-active-class="proxy?.animate.searchAnimate.enter" :leave-active-class="proxy?.animate.searchAnimate.leave">
      <div v-show="showSearch" class="mb-[10px]">
        <el-card shadow="hover">
          <el-form ref="queryFormRef" :model="queryParams" :inline="true" label-width="150px">
            <el-form-item label="食材分类名称" prop="name">
              <el-input v-model="queryParams.name" placeholder="请输入" clearable @keyup.enter="handleQuery" />
            </el-form-item>
            <el-form-item>
              <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
              <el-button icon="Refresh" @click="resetQuery">重置</el-button>
            </el-form-item>
          </el-form>
        </el-card>
      </div>
    </transition>

    <el-card shadow="never">
      <template #header>
        <el-row :gutter="10" class="mb8">
          <el-col :span="1.5">
            <el-button type="primary" icon="Plus" @click="handleAdd" v-hasPermi="['system:foodCategory:add']">新增分类</el-button>
          </el-col>

          <el-col :span="1.5">
            <el-button  @click="handleExpand" v-hasPermi="['system:foodCategory:add']">{{btnText}}</el-button>
          </el-col>

          <!-- <el-col :span="1.5">
            <el-button type="success" plain icon="Edit" :disabled="single" @click="handleUpdate()" v-hasPermi="['system:foodCategory:edit']">修改</el-button>
          </el-col>
          <el-col :span="1.5">
            <el-button type="danger" plain icon="Delete" :disabled="multiple" @click="handleDelete()" v-hasPermi="['system:foodCategory:remove']">删除</el-button>
          </el-col>
          <el-col :span="1.5">
            <el-button type="warning" plain icon="Download" @click="handleExport" v-hasPermi="['system:foodCategory:export']">导出</el-button>
          </el-col> -->
          <right-toolbar v-model:showSearch="showSearch" @queryTable="getList"></right-toolbar>
        </el-row>
      </template>

      <el-table v-loading="loading" border  stripe
       ref="foodCategoryTableRef"
       row-key="foodCategoryId"          
      :tree-props="{children: 'children', hasChildren: 'hasChildren' }"
      :default-expand-all="isExpandAll"
      :expand-row-keys="expandRowKeys"
      :data="foodCategoryList" >
        <!-- <el-table-column type="selection" width="55" align="center"  /> -->
        <!-- <el-table-column label="主键ID" align="center" prop="foodCategoryId" v-if="true" /> -->
        <el-table-column label="食材分类" align="left" prop="name" />
        <!-- <el-table-column label="上级分类ID" align="center" prop="parentId" />
        <el-table-column label="排序" align="center" prop="sort" />
        <el-table-column label="状态" align="center" prop="status" /> -->
        <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
          <template #default="scope">
            <el-tooltip content="编辑" placement="top">
              <el-button link type="primary" icon="Edit" v-if="scope.row.isDefault != 1" @click="handleUpdate(scope.row)" v-hasPermi="['system:foodCategory:edit']">编辑</el-button>
            </el-tooltip>
            <el-tooltip content="删除" placement="top">
              <el-button link type="danger" icon="Delete" v-if="scope.row.isDefault != 1" @click="handleDelete(scope.row)" v-hasPermi="['system:foodCategory:remove']">删除</el-button>
            </el-tooltip>
          </template>
        </el-table-column>
      </el-table>

      <!-- <pagination v-show="total > 0" :total="total" v-model:page="queryParams.pageNum" v-model:limit="queryParams.pageSize" @pagination="getList" /> -->
    </el-card>
    <!-- 添加或修改食材分类对话框 -->
    <el-dialog :title="dialog.title" v-model="dialog.visible" width="500px" append-to-body>
      <el-form ref="foodCategoryFormRef" :model="form" :rules="rules" label-width="80px">       
        <el-form-item label="上级分类" prop="parentId">
              <el-tree-select
              v-model="form.parentId"
              :data="foodCategoryList2"
              :render-after-expand="false" 
              :props="{ value: 'foodCategoryId', label: 'name', children: 'children' } as any"
              check-strictly=true              
            />
        </el-form-item>   
        <el-form-item label="分类名称" prop="name">
          <el-input v-model="form.name" placeholder="请输入" />
        </el-form-item>     
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button :loading="buttonLoading" type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="FoodCategory" lang="ts">
import { listFoodCategory, getFoodCategory, delFoodCategory, addFoodCategory, updateFoodCategory,listTree } from '@/api/system/foodCategory';
import { FoodCategoryVO, FoodCategoryQuery, FoodCategoryForm } from '@/api/system/foodCategory/types';
import { changeOssConfigStatus } from '@/api/system/ossConfig';

const foodCategoryTableRef = ref<ElTableInstance>();
const { proxy } = getCurrentInstance() as ComponentInternalInstance;
const isExpandAll = ref(true);
const expandRowKeys = ref<string>();
const btnText = ref('关闭所有');
const foodCategoryList = ref<FoodCategoryVO[]>([]);
const foodCategoryList2 = ref<FoodCategoryVO[]>([]);
const buttonLoading = ref(false);
const loading = ref(true);
const showSearch = ref(true);
const ids = ref<Array<string | number>>([]);
const single = ref(true);
const multiple = ref(true);
const total = ref(0);

const queryFormRef = ref<ElFormInstance>();
const foodCategoryFormRef = ref<ElFormInstance>();
const foodTableRef = ref<ElTableInstance>();


const dialog = reactive<DialogOption>({
  visible: false,
  title: ''
});

const initFormData: FoodCategoryForm = {
  foodCategoryId: undefined,
  name: undefined,
  parentId: undefined,
  sort: undefined,
  status: undefined,
}
const data = reactive<PageData<FoodCategoryForm, FoodCategoryQuery>>({
  form: {...initFormData},
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    name: undefined,
    parentId: undefined,
    sort: undefined,
    status: undefined,
    params: {
    }
  },
  rules: {
    parentId: [
      { required: true, message: "上级分类不能为空", trigger: "blur" }
    ],
    name: [
      { required: true, message: "分类名称不能为空", trigger: "blur" }
    ],
  }
});

const { queryParams, form, rules } = toRefs(data);

/** 查询食材分类列表 */
const getList = async () => {
  loading.value = true;
  const res = await listTree(queryParams.value);  
  foodCategoryList.value = res.rows;
  total.value = res.total;
  loading.value = false;
}

/** 查询食材分类列表 */
const getList2 = async () => {   
  const res = await listTree();  
  foodCategoryList2.value = res.rows;
   
}

/** 取消按钮 */
const cancel = () => {
  reset();
  dialog.visible = false;
}

/** 表单重置 */
const reset = () => {
  form.value = {...initFormData};
  foodCategoryFormRef.value?.resetFields();
}

/** 搜索按钮操作 */
const handleQuery = () => {
  queryParams.value.pageNum = 1;
  getList();
}

/** 重置按钮操作 */
const resetQuery = () => {
  queryFormRef.value?.resetFields();
  handleQuery();
}

/** 多选框选中数据 */
const handleSelectionChange = (selection: FoodCategoryVO[]) => {
  ids.value = selection.map(item => item.foodCategoryId);
  single.value = selection.length != 1;
  multiple.value = !selection.length;
}

/** 新增按钮操作 */
const handleAdd = () => {
  reset();
  getList2();
  dialog.visible = true;
  dialog.title = "添加食材分类";
}

const handleExpand = () => {
  isExpandAll.value=!isExpandAll.value;  
  // expandRowKeys.value=isExpandAll.value?[]:foodCategoryList.value.map(item=>item.foodCategoryId.toString());  
  btnText.value=isExpandAll.value?'关闭所有':'展开所有';
  toggleExpandAll(foodCategoryList.value, isExpandAll.value);
};
/** 展开/折叠所有 */
const toggleExpandAll = (data: FoodCategoryVO[], status: boolean) => {
  data.forEach((item) => {
    foodCategoryTableRef.value?.toggleRowExpansion(item, status);
    // if (item.children && item.children.length > 0) toggleExpandAll(item.children, status);
  });
};

/** 修改按钮操作 */
const handleUpdate = async (row?: FoodCategoryVO) => {
  reset();
  getList2();
  const _foodCategoryId = row?.foodCategoryId || ids.value[0]
  const res = await getFoodCategory(_foodCategoryId);
  Object.assign(form.value, res.data);
  dialog.visible = true;
  dialog.title = "修改食材分类";
}

/** 提交按钮 */
const submitForm = () => {
  foodCategoryFormRef.value?.validate(async (valid: boolean) => {
    if (valid) {
      buttonLoading.value = true;
      if (form.value.foodCategoryId) {
        await updateFoodCategory(form.value).finally(() =>  buttonLoading.value = false);
      } else {
        await addFoodCategory(form.value).finally(() =>  buttonLoading.value = false);
      }
      proxy?.$modal.msgSuccess("操作成功");
      dialog.visible = false;
      await getList();
    }
  });
}

/** 删除按钮操作 */
const handleDelete = async (row?: FoodCategoryVO) => {
  const _foodCategoryIds = row?.foodCategoryId || ids.value;
  await proxy?.$modal.confirm('是否确认删除食材分类编号为"' + _foodCategoryIds + '"的数据项？').finally(() => loading.value = false);
  await delFoodCategory(_foodCategoryIds);
  proxy?.$modal.msgSuccess("删除成功");
  await getList();
}

/** 导出按钮操作 */
const handleExport = () => {
  proxy?.download('system/foodCategory/export', {
    ...queryParams.value
  }, `foodCategory_${new Date().getTime()}.xlsx`)
}

onMounted(() => {
  getList();
});
</script>
